% Example-17: COMMON_PRE (Token selection based on Costs)
% Reggie.davidrajuh@uis.no  (c) 20 Nov 2017

function [fire, transition] = COMMON_PRE(transition)

timesFired = timesfired(transition.name); 
switch transition.name
    case 'tAddCost'
        fire = lt(timesFired, 10); return

    case 'tDelay' % tDelay fires when tAddCost has already fired 10 times
        timesfired_tAddCost = timesfired('tAddCost'); 
        fire = eq(timesfired_tAddCost,10); return
        
    case {'tChp','tMid','tExp'}      
        % allow 'tChp', 'tMid', and 'tExp' to fire ONLY 3 times
        if eq(timesFired, 3), fire = 0; return; end
        
        % we are here for the three transitions 'tChp', 'tMid', and 'tExp'
        if strcmp(transition.name, 'tChp') % tChp selects cheap tokens
            tokID = tokenCheap('pBuffer',1);
        elseif strcmp(transition.name, 'tExp') % tExp selects expensive tokens
            tokID = tokenExpensive('pBuffer', 1);
        else % 'tMid' selects tokens that cost between (270, 290)
            tokID = tokenCostBetween('pBuffer', 1, 270, 290);
        end % switch transition.name
        transition.selected_tokens = tokID;
        fire = tokID;
end
